CycleFactor := function(n,i)
  if i < 0 then return 2-n;
    else return (2*i+1)*(-1)^(2*i*(n-1));
fi; end;

rveCharacterVal := function(p,k,s)
  return 2*Product(Cycles(p,k),
    c -> CycleFactor(Length(c),s[c[1]]));
end;

rveCharacter := function(g,s)
  return List(ConjugacyClasses(g),
    p -> rveCharacterVal(Representative(p),
      MovedPoints(g),s)); end;

SpinWeights := function(g,s)
  return MatScalarProducts(Irr(g),
    [rveCharacter(g,s)])[1]; end;


### benzene dimer

b2P := Group((1,2,3,4,5,6), (2,6)(3,5),
  (1,7)(2,8)(3,9)(4,10)(5,11)(6,12));

SpinWeights(b2P, 0*[1..12]+1/2)/2;
SpinWeights(b2P, 0*[1..12]+1)/2;


### methane dimer

m2PI := Group((1,2,3), (1,2)(5,6)(9,10),
  (1,2)(3,4), (1,5)(2,6)(3,7)(4,8));

SpinWeights(m2PI, [1/2,1/2,1/2,1/2,1/2,1/2,1/2,1/2,-1,-1]);
SpinWeights(m2PI, [1,1,1,1,1,1,1,1,-1,-1]);


### 209Bi8 cube

Bi8P := Group( (1,2,3,4)(5,6,7,8), (1,2,6,5)(4,3,7,8) );

SpinWeights(Bi8P, [9/2,9/2,9/2,9/2,9/2,9/2,9/2,9/2])/2;
